#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum Scatter3dDecimationStrategy {
    #[serde(rename = "SPATIAL")]
    Spatial,
    #[serde(rename = "TEMPORAL")]
    Temporal,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl Scatter3dDecimationStrategy {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            Scatter3dDecimationStrategy::Spatial => "SPATIAL",
            Scatter3dDecimationStrategy::Temporal => "TEMPORAL",
            Scatter3dDecimationStrategy::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for Scatter3dDecimationStrategy {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for Scatter3dDecimationStrategy {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for Scatter3dDecimationStrategy {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<Scatter3dDecimationStrategy, conjure_object::plain::ParseEnumError> {
        match v {
            "SPATIAL" => Ok(Scatter3dDecimationStrategy::Spatial),
            "TEMPORAL" => Ok(Scatter3dDecimationStrategy::Temporal),
            v => v.parse().map(|v| Scatter3dDecimationStrategy::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for Scatter3dDecimationStrategy {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<Scatter3dDecimationStrategy, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the Scatter3dDecimationStrategy enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
